﻿// charting library can be downloaded through NuGet. Documentation is here:
// http://fslab.org/FSharp.Charting/
#load @"packages\FSharp.Charting.0.90.13\FSharp.Charting.fsx"
open FSharp.Charting
open System

// Different types of charts
[1;2] |> Chart.Column

[1..10] |> Chart.Bar

[-1.0 .. 0.01 .. 1.0] 
    |> List.map (fun x -> (x, x * x))
    |> Chart.Line
    |> Chart.WithStyling (Color = Drawing.Color.OrangeRed)
    |> Chart.WithTitle ("Parabola")

let languagePopularity = [ ("Java", 316); ("C#", 258); ("C++", 157) ]
languagePopularity |> Chart.Pie



// Combining charts
[-10. .. 0.1 .. 10.] |> List.map (Math.Sin) |> Chart.Line

// f'(x) = lim (h->0) (f(a + h) - f(a)) / h)
//
let derivative f =
    let f' x = (f(x + 1E-10) - f(x)) / 1E-10
    f'

let sin' = derivative Math.Sin

[
    [0. .. 0.01 .. (Math.PI * 6.)] |> List.map (sin') 
    |> fun data -> Chart.Line(data, Name = "sin`");

    [0. .. 0.01 .. (Math.PI * 6.)] |> List.map (Math.Sin) 
    |> fun data -> Chart.Line(data, Name = "sin")
    //[0. .. 0.01 .. (Math.PI * 6.)] |> List.map (Math.Cos) |> fun data -> Chart.Line(data, Name = "cos")
] |> Chart.Combine


